import java.util.Stack;


public interface UPNOperation
{
	/** Werte, deren Betrag kleiner EPSILON ist, werden als 0 angenommen.
	  * Ist speziell f&uuml;r Vergleiche zwischen double Werten wichtig. 
          */
	public static final double EPSILON = 0.000000001;

	/** F&uuml;hrt die Operation aus. 
	  * @param op Stack von dem die Werte gelesen werden. Das Ergebnis wird 
	  *           wieder auf diesen Stack geschrieben
	  * @throws InvalidParameterException Wird geworfen wenn ein ung&uuml;ltiger Parameter gefunden wird,
	  *	                              oder wenn zuwenige Parameter vorhanden sind.
          */
	public void execute (Stack<Double> op) throws InvalidParameterException;

	/** Liefert das Symbol der Operation. Zb: "+" f&uuml;r eine Addition.
	  * @returns Operationsymbol.
	  */
	public String getOperationSymbol ();
}
